// Generated from org/mintshell/mcl/MCL.g4 by ANTLR 4.5
package org.mintshell.mcl;
import org.antlr.v4.runtime.atn.*;
import org.antlr.v4.runtime.dfa.DFA;
import org.antlr.v4.runtime.*;
import org.antlr.v4.runtime.misc.*;
import org.antlr.v4.runtime.tree.*;
import java.util.List;
import java.util.Iterator;
import java.util.ArrayList;

@SuppressWarnings({"all", "warnings", "unchecked", "unused", "cast"})
public class MCLParser extends Parser {
	static { RuntimeMetaData.checkVersion("4.5", RuntimeMetaData.VERSION); }

	protected static final DFA[] _decisionToDFA;
	protected static final PredictionContextCache _sharedContextCache =
		new PredictionContextCache();
	public static final int
		PIPE=1, SHORT_COMMAND_PARAMETER_PREFIX=2, LONG_COMMAND_PARAMETER_PREFIX=3, 
		CHARACTER=4, UNQUOTED=5, QUOTED=6, SPACE=7;
	public static final int
		RULE_commandLine = 0, RULE_pipedCommand = 1, RULE_command = 2, RULE_commandName = 3, 
		RULE_commandParameter = 4, RULE_commandParameterValue = 5, RULE_shortCommandParameter = 6, 
		RULE_shortCommandParameterName = 7, RULE_longCommandParameter = 8, RULE_longCommandParameterName = 9;
	public static final String[] ruleNames = {
		"commandLine", "pipedCommand", "command", "commandName", "commandParameter", 
		"commandParameterValue", "shortCommandParameter", "shortCommandParameterName", 
		"longCommandParameter", "longCommandParameterName"
	};

	private static final String[] _LITERAL_NAMES = {
		null, "'|'", "'-'", "'--'"
	};
	private static final String[] _SYMBOLIC_NAMES = {
		null, "PIPE", "SHORT_COMMAND_PARAMETER_PREFIX", "LONG_COMMAND_PARAMETER_PREFIX", 
		"CHARACTER", "UNQUOTED", "QUOTED", "SPACE"
	};
	public static final Vocabulary VOCABULARY = new VocabularyImpl(_LITERAL_NAMES, _SYMBOLIC_NAMES);

	/**
	 * @deprecated Use {@link #VOCABULARY} instead.
	 */
	@Deprecated
	public static final String[] tokenNames;
	static {
		tokenNames = new String[_SYMBOLIC_NAMES.length];
		for (int i = 0; i < tokenNames.length; i++) {
			tokenNames[i] = VOCABULARY.getLiteralName(i);
			if (tokenNames[i] == null) {
				tokenNames[i] = VOCABULARY.getSymbolicName(i);
			}

			if (tokenNames[i] == null) {
				tokenNames[i] = "<INVALID>";
			}
		}
	}

	@Override
	@Deprecated
	public String[] getTokenNames() {
		return tokenNames;
	}

	@Override

	public Vocabulary getVocabulary() {
		return VOCABULARY;
	}

	@Override
	public String getGrammarFileName() { return "MCL.g4"; }

	@Override
	public String[] getRuleNames() { return ruleNames; }

	@Override
	public String getSerializedATN() { return _serializedATN; }

	@Override
	public ATN getATN() { return _ATN; }

	public MCLParser(TokenStream input) {
		super(input);
		_interp = new ParserATNSimulator(this,_ATN,_decisionToDFA,_sharedContextCache);
	}
	public static class CommandLineContext extends ParserRuleContext {
		public CommandContext command() {
			return getRuleContext(CommandContext.class,0);
		}
		public List<PipedCommandContext> pipedCommand() {
			return getRuleContexts(PipedCommandContext.class);
		}
		public PipedCommandContext pipedCommand(int i) {
			return getRuleContext(PipedCommandContext.class,i);
		}
		public CommandLineContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_commandLine; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).enterCommandLine(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).exitCommandLine(this);
		}
	}

	public final CommandLineContext commandLine() throws RecognitionException {
		CommandLineContext _localctx = new CommandLineContext(_ctx, getState());
		enterRule(_localctx, 0, RULE_commandLine);
		int _la;
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(20);
			command();
			setState(24);
			_errHandler.sync(this);
			_la = _input.LA(1);
			while (_la==SPACE) {
				{
				{
				setState(21);
				pipedCommand();
				}
				}
				setState(26);
				_errHandler.sync(this);
				_la = _input.LA(1);
			}
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class PipedCommandContext extends ParserRuleContext {
		public TerminalNode PIPE() { return getToken(MCLParser.PIPE, 0); }
		public CommandContext command() {
			return getRuleContext(CommandContext.class,0);
		}
		public List<TerminalNode> SPACE() { return getTokens(MCLParser.SPACE); }
		public TerminalNode SPACE(int i) {
			return getToken(MCLParser.SPACE, i);
		}
		public PipedCommandContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_pipedCommand; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).enterPipedCommand(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).exitPipedCommand(this);
		}
	}

	public final PipedCommandContext pipedCommand() throws RecognitionException {
		PipedCommandContext _localctx = new PipedCommandContext(_ctx, getState());
		enterRule(_localctx, 2, RULE_pipedCommand);
		int _la;
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(28); 
			_errHandler.sync(this);
			_la = _input.LA(1);
			do {
				{
				{
				setState(27);
				match(SPACE);
				}
				}
				setState(30); 
				_errHandler.sync(this);
				_la = _input.LA(1);
			} while ( _la==SPACE );
			setState(32);
			match(PIPE);
			setState(34); 
			_errHandler.sync(this);
			_la = _input.LA(1);
			do {
				{
				{
				setState(33);
				match(SPACE);
				}
				}
				setState(36); 
				_errHandler.sync(this);
				_la = _input.LA(1);
			} while ( _la==SPACE );
			setState(38);
			command();
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class CommandContext extends ParserRuleContext {
		public CommandNameContext commandName() {
			return getRuleContext(CommandNameContext.class,0);
		}
		public List<CommandParameterContext> commandParameter() {
			return getRuleContexts(CommandParameterContext.class);
		}
		public CommandParameterContext commandParameter(int i) {
			return getRuleContext(CommandParameterContext.class,i);
		}
		public List<TerminalNode> SPACE() { return getTokens(MCLParser.SPACE); }
		public TerminalNode SPACE(int i) {
			return getToken(MCLParser.SPACE, i);
		}
		public CommandContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_command; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).enterCommand(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).exitCommand(this);
		}
	}

	public final CommandContext command() throws RecognitionException {
		CommandContext _localctx = new CommandContext(_ctx, getState());
		enterRule(_localctx, 4, RULE_command);
		int _la;
		try {
			int _alt;
			enterOuterAlt(_localctx, 1);
			{
			setState(40);
			commandName();
			setState(49);
			_errHandler.sync(this);
			_alt = getInterpreter().adaptivePredict(_input,4,_ctx);
			while ( _alt!=2 && _alt!=org.antlr.v4.runtime.atn.ATN.INVALID_ALT_NUMBER ) {
				if ( _alt==1 ) {
					{
					{
					setState(42); 
					_errHandler.sync(this);
					_la = _input.LA(1);
					do {
						{
						{
						setState(41);
						match(SPACE);
						}
						}
						setState(44); 
						_errHandler.sync(this);
						_la = _input.LA(1);
					} while ( _la==SPACE );
					setState(46);
					commandParameter();
					}
					} 
				}
				setState(51);
				_errHandler.sync(this);
				_alt = getInterpreter().adaptivePredict(_input,4,_ctx);
			}
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class CommandNameContext extends ParserRuleContext {
		public TerminalNode CHARACTER() { return getToken(MCLParser.CHARACTER, 0); }
		public TerminalNode UNQUOTED() { return getToken(MCLParser.UNQUOTED, 0); }
		public TerminalNode QUOTED() { return getToken(MCLParser.QUOTED, 0); }
		public CommandNameContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_commandName; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).enterCommandName(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).exitCommandName(this);
		}
	}

	public final CommandNameContext commandName() throws RecognitionException {
		CommandNameContext _localctx = new CommandNameContext(_ctx, getState());
		enterRule(_localctx, 6, RULE_commandName);
		int _la;
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(52);
			_la = _input.LA(1);
			if ( !((((_la) & ~0x3f) == 0 && ((1L << _la) & ((1L << CHARACTER) | (1L << UNQUOTED) | (1L << QUOTED))) != 0)) ) {
			_errHandler.recoverInline(this);
			} else {
				consume();
			}
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class CommandParameterContext extends ParserRuleContext {
		public ShortCommandParameterContext shortCommandParameter() {
			return getRuleContext(ShortCommandParameterContext.class,0);
		}
		public LongCommandParameterContext longCommandParameter() {
			return getRuleContext(LongCommandParameterContext.class,0);
		}
		public CommandParameterValueContext commandParameterValue() {
			return getRuleContext(CommandParameterValueContext.class,0);
		}
		public List<TerminalNode> SPACE() { return getTokens(MCLParser.SPACE); }
		public TerminalNode SPACE(int i) {
			return getToken(MCLParser.SPACE, i);
		}
		public CommandParameterContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_commandParameter; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).enterCommandParameter(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).exitCommandParameter(this);
		}
	}

	public final CommandParameterContext commandParameter() throws RecognitionException {
		CommandParameterContext _localctx = new CommandParameterContext(_ctx, getState());
		enterRule(_localctx, 8, RULE_commandParameter);
		int _la;
		try {
			setState(67);
			switch (_input.LA(1)) {
			case SHORT_COMMAND_PARAMETER_PREFIX:
			case LONG_COMMAND_PARAMETER_PREFIX:
				enterOuterAlt(_localctx, 1);
				{
				{
				setState(56);
				switch (_input.LA(1)) {
				case SHORT_COMMAND_PARAMETER_PREFIX:
					{
					setState(54);
					shortCommandParameter();
					}
					break;
				case LONG_COMMAND_PARAMETER_PREFIX:
					{
					setState(55);
					longCommandParameter();
					}
					break;
				default:
					throw new NoViableAltException(this);
				}
				setState(64);
				switch ( getInterpreter().adaptivePredict(_input,7,_ctx) ) {
				case 1:
					{
					setState(59); 
					_errHandler.sync(this);
					_la = _input.LA(1);
					do {
						{
						{
						setState(58);
						match(SPACE);
						}
						}
						setState(61); 
						_errHandler.sync(this);
						_la = _input.LA(1);
					} while ( _la==SPACE );
					setState(63);
					commandParameterValue();
					}
					break;
				}
				}
				}
				break;
			case CHARACTER:
			case UNQUOTED:
			case QUOTED:
				enterOuterAlt(_localctx, 2);
				{
				setState(66);
				commandParameterValue();
				}
				break;
			default:
				throw new NoViableAltException(this);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class CommandParameterValueContext extends ParserRuleContext {
		public TerminalNode CHARACTER() { return getToken(MCLParser.CHARACTER, 0); }
		public TerminalNode UNQUOTED() { return getToken(MCLParser.UNQUOTED, 0); }
		public TerminalNode QUOTED() { return getToken(MCLParser.QUOTED, 0); }
		public CommandParameterValueContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_commandParameterValue; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).enterCommandParameterValue(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).exitCommandParameterValue(this);
		}
	}

	public final CommandParameterValueContext commandParameterValue() throws RecognitionException {
		CommandParameterValueContext _localctx = new CommandParameterValueContext(_ctx, getState());
		enterRule(_localctx, 10, RULE_commandParameterValue);
		int _la;
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(69);
			_la = _input.LA(1);
			if ( !((((_la) & ~0x3f) == 0 && ((1L << _la) & ((1L << CHARACTER) | (1L << UNQUOTED) | (1L << QUOTED))) != 0)) ) {
			_errHandler.recoverInline(this);
			} else {
				consume();
			}
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ShortCommandParameterContext extends ParserRuleContext {
		public TerminalNode SHORT_COMMAND_PARAMETER_PREFIX() { return getToken(MCLParser.SHORT_COMMAND_PARAMETER_PREFIX, 0); }
		public ShortCommandParameterNameContext shortCommandParameterName() {
			return getRuleContext(ShortCommandParameterNameContext.class,0);
		}
		public ShortCommandParameterContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_shortCommandParameter; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).enterShortCommandParameter(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).exitShortCommandParameter(this);
		}
	}

	public final ShortCommandParameterContext shortCommandParameter() throws RecognitionException {
		ShortCommandParameterContext _localctx = new ShortCommandParameterContext(_ctx, getState());
		enterRule(_localctx, 12, RULE_shortCommandParameter);
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(71);
			match(SHORT_COMMAND_PARAMETER_PREFIX);
			setState(72);
			shortCommandParameterName();
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ShortCommandParameterNameContext extends ParserRuleContext {
		public TerminalNode CHARACTER() { return getToken(MCLParser.CHARACTER, 0); }
		public ShortCommandParameterNameContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_shortCommandParameterName; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).enterShortCommandParameterName(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).exitShortCommandParameterName(this);
		}
	}

	public final ShortCommandParameterNameContext shortCommandParameterName() throws RecognitionException {
		ShortCommandParameterNameContext _localctx = new ShortCommandParameterNameContext(_ctx, getState());
		enterRule(_localctx, 14, RULE_shortCommandParameterName);
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(74);
			match(CHARACTER);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class LongCommandParameterContext extends ParserRuleContext {
		public TerminalNode LONG_COMMAND_PARAMETER_PREFIX() { return getToken(MCLParser.LONG_COMMAND_PARAMETER_PREFIX, 0); }
		public LongCommandParameterNameContext longCommandParameterName() {
			return getRuleContext(LongCommandParameterNameContext.class,0);
		}
		public LongCommandParameterContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_longCommandParameter; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).enterLongCommandParameter(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).exitLongCommandParameter(this);
		}
	}

	public final LongCommandParameterContext longCommandParameter() throws RecognitionException {
		LongCommandParameterContext _localctx = new LongCommandParameterContext(_ctx, getState());
		enterRule(_localctx, 16, RULE_longCommandParameter);
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(76);
			match(LONG_COMMAND_PARAMETER_PREFIX);
			setState(77);
			longCommandParameterName();
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class LongCommandParameterNameContext extends ParserRuleContext {
		public TerminalNode CHARACTER() { return getToken(MCLParser.CHARACTER, 0); }
		public TerminalNode UNQUOTED() { return getToken(MCLParser.UNQUOTED, 0); }
		public LongCommandParameterNameContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_longCommandParameterName; }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).enterLongCommandParameterName(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof MCLListener ) ((MCLListener)listener).exitLongCommandParameterName(this);
		}
	}

	public final LongCommandParameterNameContext longCommandParameterName() throws RecognitionException {
		LongCommandParameterNameContext _localctx = new LongCommandParameterNameContext(_ctx, getState());
		enterRule(_localctx, 18, RULE_longCommandParameterName);
		int _la;
		try {
			enterOuterAlt(_localctx, 1);
			{
			setState(79);
			_la = _input.LA(1);
			if ( !(_la==CHARACTER || _la==UNQUOTED) ) {
			_errHandler.recoverInline(this);
			} else {
				consume();
			}
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static final String _serializedATN =
		"\3\u0430\ud6d1\u8206\uad2d\u4417\uaef1\u8d80\uaadd\3\tT\4\2\t\2\4\3\t"+
		"\3\4\4\t\4\4\5\t\5\4\6\t\6\4\7\t\7\4\b\t\b\4\t\t\t\4\n\t\n\4\13\t\13\3"+
		"\2\3\2\7\2\31\n\2\f\2\16\2\34\13\2\3\3\6\3\37\n\3\r\3\16\3 \3\3\3\3\6"+
		"\3%\n\3\r\3\16\3&\3\3\3\3\3\4\3\4\6\4-\n\4\r\4\16\4.\3\4\7\4\62\n\4\f"+
		"\4\16\4\65\13\4\3\5\3\5\3\6\3\6\5\6;\n\6\3\6\6\6>\n\6\r\6\16\6?\3\6\5"+
		"\6C\n\6\3\6\5\6F\n\6\3\7\3\7\3\b\3\b\3\b\3\t\3\t\3\n\3\n\3\n\3\13\3\13"+
		"\3\13\2\2\f\2\4\6\b\n\f\16\20\22\24\2\4\3\2\6\b\3\2\6\7R\2\26\3\2\2\2"+
		"\4\36\3\2\2\2\6*\3\2\2\2\b\66\3\2\2\2\nE\3\2\2\2\fG\3\2\2\2\16I\3\2\2"+
		"\2\20L\3\2\2\2\22N\3\2\2\2\24Q\3\2\2\2\26\32\5\6\4\2\27\31\5\4\3\2\30"+
		"\27\3\2\2\2\31\34\3\2\2\2\32\30\3\2\2\2\32\33\3\2\2\2\33\3\3\2\2\2\34"+
		"\32\3\2\2\2\35\37\7\t\2\2\36\35\3\2\2\2\37 \3\2\2\2 \36\3\2\2\2 !\3\2"+
		"\2\2!\"\3\2\2\2\"$\7\3\2\2#%\7\t\2\2$#\3\2\2\2%&\3\2\2\2&$\3\2\2\2&\'"+
		"\3\2\2\2\'(\3\2\2\2()\5\6\4\2)\5\3\2\2\2*\63\5\b\5\2+-\7\t\2\2,+\3\2\2"+
		"\2-.\3\2\2\2.,\3\2\2\2./\3\2\2\2/\60\3\2\2\2\60\62\5\n\6\2\61,\3\2\2\2"+
		"\62\65\3\2\2\2\63\61\3\2\2\2\63\64\3\2\2\2\64\7\3\2\2\2\65\63\3\2\2\2"+
		"\66\67\t\2\2\2\67\t\3\2\2\28;\5\16\b\29;\5\22\n\2:8\3\2\2\2:9\3\2\2\2"+
		";B\3\2\2\2<>\7\t\2\2=<\3\2\2\2>?\3\2\2\2?=\3\2\2\2?@\3\2\2\2@A\3\2\2\2"+
		"AC\5\f\7\2B=\3\2\2\2BC\3\2\2\2CF\3\2\2\2DF\5\f\7\2E:\3\2\2\2ED\3\2\2\2"+
		"F\13\3\2\2\2GH\t\2\2\2H\r\3\2\2\2IJ\7\4\2\2JK\5\20\t\2K\17\3\2\2\2LM\7"+
		"\6\2\2M\21\3\2\2\2NO\7\5\2\2OP\5\24\13\2P\23\3\2\2\2QR\t\3\2\2R\25\3\2"+
		"\2\2\13\32 &.\63:?BE";
	public static final ATN _ATN =
		new ATNDeserializer().deserialize(_serializedATN.toCharArray());
	static {
		_decisionToDFA = new DFA[_ATN.getNumberOfDecisions()];
		for (int i = 0; i < _ATN.getNumberOfDecisions(); i++) {
			_decisionToDFA[i] = new DFA(_ATN.getDecisionState(i), i);
		}
	}
}